//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include "DigitDetector.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <complex>
using namespace std;
//---------------------------------------------------------------------------
class TBatchDetectForm : public TForm
{
__published:	// IDE-managed Components
	TPaintBox *PaintBox1;
	TScrollBar *ScrollBar1;
	TBevel *Bevel1;
	TCheckBox *CBSignalDiff;
	TCheckBox *CBSignal;
	TMemo *Memo1;
	TCheckBox *CBSignalLevel;
	TOpenDialog *OpenDialog1;
	TSpeedButton *SpeedButton9;
	TSpeedButton *SpeedButton10;
	TSpeedButton *SpeedButton11;
	TSpeedButton *SpeedButton12;
	TLabel *Label11;
	TBevel *Bevel3;
	TLabel *Label12;
	TDigitDetector *DigitDetector1;
	TCheckBox *CBConfirm;
	TLabel *Label13;
	TLabel *Label1;
	TGroupBox *GroupBox1;
	TLabel *Label10;
	TButton *Button27;
	TButton *Button26;
	TButton *Button16;
	TButton *Button24;
	TButton *Button28;
	TButton *Button29;
	TEdit *EDCoef;
	TButton *Button23;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TStatusBar *StatusBar1;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *Label9;
	TCheckBox *CBNormalized;
	TLabel *Label14;
	TLabel *Label15;
	TLabel *Label16;
	TLabel *Label17;
	TBevel *Bevel2;
	TSpeedButton *BTOpen;
	TSpeedButton *BTStop;
	TCheckBox *CheckBox1;
	TComboBox *ComboBox1;
	TLabel *Label18;
	TBevel *Bevel4;
	TPopupMenu *PopupMenu1;
	TMenuItem *Help1;
	void __fastcall Button16Click(TObject *Sender);
	void __fastcall EDCoefChange(TObject *Sender);
	void __fastcall ScrollBar1Change(TObject *Sender);
	void __fastcall Button23Click(TObject *Sender);
	void __fastcall PaintBox1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall PaintBox1Paint(TObject *Sender);
	void __fastcall Button24Click(TObject *Sender);
	void __fastcall Button25Click(TObject *Sender);
	void __fastcall SpeedButton9Click(TObject *Sender);
	void __fastcall SpeedButton10Click(TObject *Sender);
	void __fastcall SpeedButton12Click(TObject *Sender);
	void __fastcall SpeedButton11Click(TObject *Sender);
	void __fastcall Button26Click(TObject *Sender);
	void __fastcall Button27Click(TObject *Sender);
	void __fastcall PaintBox1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall Button28Click(TObject *Sender);
	void __fastcall Button29Click(TObject *Sender);
	void __fastcall DigitDetector1DoSupplyBuffer(TComponent *Sender,
          short *&Buffer, int &Length, bool &aIsLastBuffer, int Position);
	void __fastcall DigitDetector1DigitDetected(TComponent *Sender,
          char Digit, unsigned TimeTicks, bool IsDTMF);
	void __fastcall DigitDetector1DetectionEnd(TObject *Sender);
	void __fastcall Button30Click(TObject *Sender);
	void __fastcall CheckBoxClick(TObject *Sender);
	void __fastcall CheckBox1Click(TObject *Sender);
	void __fastcall ComboBox1Change(TObject *Sender);
	void __fastcall Help1Click(TObject *Sender);


private:	// User declarations
	float *mGraph;
	TPulse **mPulseList;
	int mStartPoint, mEndPoint, mPulseCount, mNextActivityPoint;
	complex<double> *mFFTBuffer;
	int mVirtualWaveInPosition;
	bool mScrolled ;
	float mLevelZoom, mTimeZoom ;
	int mWindowStartPoint, mWindowEndPoint, mCursorPoint, mSelectionStartPoint, mSelectionEndPoint ;

	char * mBuffer ;
	char * mSampleBuffer ;
	unsigned short int * mSampleDeltaBuffer;
	float * mSampleLevelBuffer ;
	int mSampleLength, mProcessingPosition, mToneOffset, mPulseOffset ;

	AnsiString mFileName, mFullPathFilename, mNumber, mFileNumber;
	FILE * mCurrentFile ;
	int mFileIndex ;


public:		// User declarations
	float mCoefficient, mAmbienceCoefficient, mPulseCoefficient ;
	AnsiString mRegions ;
	void __fastcall ExtractFileName() ;
	void __fastcall ConfigScrollBar() ;
	__fastcall TBatchDetectForm(TComponent* Owner);
	__fastcall ~TBatchDetectForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TBatchDetectForm *BatchDetectForm;
//---------------------------------------------------------------------------
#endif
