//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "MultimediaTimer.h"
#include <ExtCtrls.hpp>
#include "WaveDevice.h"
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
struct stereo_data
{
	short int left ;
	short int right ;
} ;
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TComboBox *ComboBox1;
	TComboBox *ComboBox2;
	TLabel *Label1;
	TLabel *Label2;
	TTrackBar *TBRecord;
	TComboBox *ComboBox3;
	TLabel *Label9;
	TComboBox *ComboBox4;
	TLabel *Label10;
	TPaintBox *PaintBox1;
	TBevel *Bevel1;
	TLabel *Label3;
	TLabel *Label4;
	TPaintBox *PaintBox2;
	TBevel *Bevel2;
	TSpeedButton *SBStop;
	TSpeedButton *SBPlay;
	TSpeedButton *SBRecord;
	TSpeedButton *SBForward;
	TSpeedButton *SBRewind;
	TLabel *Label5;
	TLabel *Label6;
	TMultimediaTimer *MultimediaTimer1;
	TLabel *Label7;
	TLabel *Label8;
	TLabel *LBLength;
	TLabel *LBPosition;
	TLabel *Label11;
	TBevel *Bevel3;
	TMainMenu *MainMenu1;
	TMenuItem *File1;
	TMenuItem *New;
	TMenuItem *Open;
	TMenuItem *Save1;
	TMenuItem *SaveAs;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TLabel *Label12;
	TMenuItem *Help1;
	TWaveDevice *WaveDevice1;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall SettingsChange(TObject *Sender);
	void __fastcall TBRecordChange(TObject *Sender);
	void __fastcall WaveDeviceError(TComponent *Sender,
          char *ErrorText, int ErrorCode);
	void __fastcall SBRewindClick(TObject *Sender);
	void __fastcall SBPlayClick(TObject *Sender);
	void __fastcall MultimediaTimer1Timer(TObject *Sender);
	void __fastcall SBRecordClick(TObject *Sender);
	void __fastcall SBStopClick(TObject *Sender);
	void __fastcall SBForwardClick(TObject *Sender);
	void __fastcall OpenClick(TObject *Sender);
	void __fastcall NewClick(TObject *Sender);
	void __fastcall SaveAsClick(TObject *Sender);
	void __fastcall PaintBoxPaint(TObject *Sender);
	void __fastcall Help1Click(TObject *Sender);

private:	// User declarations
	bool mIsPlaying, mIsRecording ;
	int mSampleSize, mPlaybackSize, mBufferSize, mSelStart, mWindow, mPosition ;
	char *mPlaybackBuffer ;

public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
