//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "MultimediaTimer.h"
#include <ExtCtrls.hpp>
#include "WaveDevice.h"
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TMultimediaTimer *MultimediaTimer1;
	TWaveDevice *WaveDevice1;
	TComboBox *ComboBox1;
	TComboBox *ComboBox2;
	TLabel *Label1;
	TLabel *Label2;
	TTrackBar *TBDelay;
	TSpeedButton *SBPause;
	TSpeedButton *SPStart;
	TSpeedButton *SPStop;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *LBDelay;
	TLabel *LBActualDelay;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *Label7;
	TLabel *Label8;
	TPopupMenu *PopupMenu1;
	TMenuItem *Help1;
	void __fastcall MultimediaTimer1Timer(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall ComboBox1Change(TObject *Sender);
	void __fastcall ComboBox2Change(TObject *Sender);
	void __fastcall SPStopClick(TObject *Sender);
	void __fastcall SPStartClick(TObject *Sender);
	void __fastcall SBPauseClick(TObject *Sender);
	void __fastcall TBDelayChange(TObject *Sender);
	void __fastcall Help1Click(TObject *Sender);

private:	// User declarations
	bool mIsRepeating, mIsPaused ;
	int mWaveOutBufferCount ;

public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
